﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Pixoneer.NXDL; // 추가

namespace XDL_DataStructure
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {

        }

        private void buttonXAngle_Click(object sender, EventArgs e)
        {
            // XAngle을 이용하여 Degree값을 DMS나 Radian값으로 변경하는 예제.
            // 1. 객체의 선언
            XAngle angle1 = new XAngle();
            XAngle angle2 = new XAngle(0.634345152625095); // 라디안 값을 입력

            // 2. 각도가 동일한지 여부 체크
            angle1.deg = 36.34530;
            if (angle1.IsEqual(angle2))
            {
                Console.WriteLine("Equal");
            }

            // 3. 변환값의 프린팅
            int nDeg, nMin;
            double sec;
            nDeg = nMin = 0;
            sec = 0;
            angle1.GetDms(ref nDeg, ref nMin, ref sec);
            Console.WriteLine("Degree : " + angle1.deg.ToString());
            Console.WriteLine("DMS : " + nDeg.ToString() + " deg, " + nMin.ToString() + " min, " + sec.ToString() + " sec");
            Console.WriteLine("Radian : " + angle1.rad.ToString());
        }

        private void buttonXVertex2i_Click(object sender, EventArgs e)
        {
            // XVertex2i는 2차원 점 좌표를 설정하는 x, y값을 갖는 데이터 구조에 해당합니다.
            // XVertex2i에서 2는 2차원을 의미하고 i는 integer을 의미합니다.
            // XVertex2i객체를 이용하여 기본 4칙연산은 물론이고, Dot Product나 Normalize등의 연산도 가능합니다.

            // 1. 객체의 선언
            XVertex2i v1 = new XVertex2i(100, 200);
            XVertex2i v2 = new XVertex2i();
            v2.x = 400; v2.y = 500;

            // 2. XVertex2i 객체의 연산
            XVertex2i v3 = v1 + v2;
            XVertex2i v4 = 5 * v3 * 10;
            XVertex2i v5 = v4 - v1;
            double dotV1V2 = v1.dotProduct(v2);
            double normV1 = v1.norm();

            // 3. 결과값의 프린팅.
            Console.WriteLine("x : " + v3.x.ToString() + " y : " + v3.y.ToString());
            Console.WriteLine("x : " + v4.x.ToString() + " y : " + v4.y.ToString());
            Console.WriteLine("x : " + v5.x.ToString() + " y : " + v5.y.ToString());
            Console.WriteLine("dot v1 v2 : " + dotV1V2.ToString());
            Console.WriteLine("norm v1 : " + normV1.ToString());  
        }

        private void buttonXVertex2d_Click(object sender, EventArgs e)
        {
            // XVertex2d는 2차원 점 좌표를 설정하는 x, y값을 갖는 데이터 구조에 해당합니다.
            // XVertex2d에서 2는 2차원을 의미하고 d는 double을 의미합니다.
            // XVertex2d객체를 이용하여 기본 4칙연산은 물론이고, Dot Product나 Normalize등의 연산도 가능합니다.

            // 1. 객체의 선언
            XVertex2d v1 = new XVertex2d(100.2, 200.5);
            XVertex2d v2 = new XVertex2d();
            v2.x = 400.2; v2.y = 500.5;

            // 2. XVertex2d 객체의 연산
            XVertex2d v3 = v1 + v2;
            XVertex2d v4 = 5 * v3 * 10;
            XVertex2d v5 = v4 - v1;
            double dotV1V2 = v1.dotProduct(v2); // Dot Product 연산
            double normV1 = v1.norm();          // Norm 계산

            // 3. 결과값의 프린팅.
            Console.WriteLine("x : " + v3.x.ToString() + " y : " + v3.y.ToString());
            Console.WriteLine("x : " + v4.x.ToString() + " y : " + v4.y.ToString());
            Console.WriteLine("x : " + v5.x.ToString() + " y : " + v5.y.ToString());
            Console.WriteLine("dot v1 v2 : " + dotV1V2.ToString());
            Console.WriteLine("norm v1 : " + normV1.ToString());
        }

        private void buttonXVertex3d_Click(object sender, EventArgs e)
        {
            // XVertex3d는 3차원 점 좌표를 설정하는 x, y, z값을 갖는 데이터 구조에 해당합니다.
            // XVertex3d에서 3는 3차원을 의미하고 d는 double을 의미합니다.
            // XVertex3d객체를 이용하여 기본 4칙연산은 물론이고, Dot Product나 Normalize등의 연산도 가능합니다.

            // 1. 객체의 선언
            XVertex3d v1 = new XVertex3d(100, 200, 300);
            XVertex3d v2 = new XVertex3d();
            v2.x = 400; v2.y = 500; v2.z = 600;

            // 2. XVertex3d 객체의 연산
            XVertex3d v3 = v1 + v2;
            XVertex3d v4 = 5 * v3 * 10;
            XVertex3d v5 = v4 - v1;
            double dotV1V2 = v1.dotProduct(v2);
            double normV1 = v1.norm();

            // 3. 결과값의 프린팅.
            Console.WriteLine("x : " + v3.x.ToString() + " y : " + v3.y.ToString() + " z : " + v3.z.ToString());
            Console.WriteLine("x : " + v4.x.ToString() + " y : " + v4.y.ToString() + " z : " + v4.z.ToString());
            Console.WriteLine("x : " + v5.x.ToString() + " y : " + v5.y.ToString() + " z : " + v5.z.ToString());
            Console.WriteLine("dot v1 v2 : " + dotV1V2.ToString());
            Console.WriteLine("norm v1 : " + normV1.ToString());
        }

        private void buttonXVertex4d_Click(object sender, EventArgs e)
        {
            // XVertex4d는 4차원 점 좌표를 설정하는 x, y, z, w값을 갖는 데이터 구조에 해당합니다.
            // XVertex4d에서 4는 4차원을 의미하고 d는 double을 의미합니다.
            // XVertex4d객체를 이용하여 기본 4칙연산은 물론이고, Normalize등의 연산도 가능합니다.

            // 1. 객체의 선언
            XVertex4d v1 = new XVertex4d(100, 200, 300, 400);
            XVertex4d v2 = new XVertex4d();
            v2.x = 400; v2.y = 500; v2.z = 600; v2.w = 700;

            // 2. XVertex4d 객체의 연산
            XVertex4d v3 = v1 + v2;
            XVertex4d v4 = 5 * v3 * 10;
            XVertex4d v5 = v4 - v1;
            double normV1 = v1.norm();

            // 3. 결과값의 프린팅.
            Console.WriteLine("x : " + v3.x.ToString() + " y : " + v3.y.ToString() + " z : " + v3.z.ToString());
            Console.WriteLine("x : " + v4.x.ToString() + " y : " + v4.y.ToString() + " z : " + v4.z.ToString());
            Console.WriteLine("x : " + v5.x.ToString() + " y : " + v5.y.ToString() + " z : " + v5.z.ToString());
            Console.WriteLine("norm v1 : " + normV1.ToString());
        }

        private void buttonXGeoPoint_Click(object sender, EventArgs e)
        {
            // XGeoPoint는 위경도 좌표와 ECEF 좌표간의 상호 변환을 수행하며 다양한 타 클래스의 입력객체로 활용된다.
            // 3차원 지구좌표의 계산 및 도시를 수행시 위경도와 ECEF좌표사이의 변환이 빈번히 일어나는데 이때 활용이 가능하다.

            // 1. 위경도 좌표값으로 부터 XGeoPoint객체를 생성
            XGeoPoint geoPos1 = XGeoPoint.FromDegree(127.123, 36.1234, 258);

            // 2. XGeoPoint객체로부터 Radian값으로 변환이 가능하며 Radian값으로부터 XGeoPoint객체를 생성
            XGeoPoint geoPos2 = XGeoPoint.FromRadian(geoPos1.lonr, geoPos1.latr, geoPos1.hgt);

            // 3. 두 XGeoPoint객체의 값이 동일한지 여부 확인
            if (geoPos1.IsEqual(geoPos2))
            {
                Console.WriteLine("geoPos1 is equal to geoPos2");
            }
            else
            {
                Console.WriteLine("geoPos1 is not equal to geoPos2");
            }

            // 4. XGeoPoint객체로부터 ECEF좌표값을 XVertex3d으로 얻는다.
            XVertex3d v1 = geoPos1.ecr;

            // 5. ECEF좌표값을 이용하여 XGeoPoint값을 생성한다. 
            XGeoPoint geopos3 = XGeoPoint.FromEcr(ref v1);
            if (geopos3.IsEqual(geoPos1))
            {
                Console.WriteLine("geoPos3 is equal to geoPos1");
            }
            else
            {
                Console.WriteLine("geoPos3 is not equal to geoPos1");
            }
        }

        private void buttonXColorTable_Click(object sender, EventArgs e)
        {
            // 1. ColorTable이 기정의된 Table의 수를 얻는다.
            int nNumColorTable = Enum.GetNames(typeof(eColorTable)).Length;
            Console.WriteLine("ColorTable 수 : " + nNumColorTable.ToString());

            // 2. 기 정의된 ColorTable의 이름을 얻어서 프린트한다.
            String[] arrPNmaes = XColorTable.GetPaletteNameList();
            for (int i=0; i<arrPNmaes.Length; i++)
            {
                Console.WriteLine(arrPNmaes[i]);
            }
        
            // 3. XColorTable의 객체를 생성하고 Rainbow ColorTable을 설정한다. 
            XColorTable clrTbl = new XColorTable();
            clrTbl.LoadColorTable(eColorTable.Rainbow);

            // 4. 각 256개의 칼라 테이블에 존재하는 r, g, b값을 얻어서 출력한다.
            byte r, g, b;
            r = g = b = 0;
            for (int i=0; i<=255; i++)
            {
                clrTbl.GetCLT(i, ref r, ref g, ref b);
                Console.WriteLine("Index " + i.ToString() + ", " + "R : " + r.ToString() + ", " + "G : " + g.ToString() + ", " + "B : " + b.ToString());
            }
            
            // 5. 일부 구간을 0으로 채운다.
            for (int i=0; i<=100; i++)
            {
                clrTbl.SetCLT(i, 0, 0, 0);
            }

            // 6. 각 256개의 칼라 테이블에 존재하는 r, g, b값을 얻어서 출력한다. 일부구간이 0으로 변경되었는지 확인한다.
            r = g = b = 0;
            for (int i = 0; i <= 255; i++)
            {
                clrTbl.GetCLT(i, ref r, ref g, ref b);
                Console.WriteLine("Index " + i.ToString() + ", " + "R : " + r.ToString() + ", " + "G : " + g.ToString() + ", " + "B : " + b.ToString());
            }

        }

        private void buttonXGrid_Click(object sender, EventArgs e)
        {
            // 1. 32bit signed Integer형의 3x3형태의 XGrid객체를 생성한다. 
            XGrid grid = new XGrid(3, 3, eDataType.SINT32);

            // 2. grid객체에 값을 입력한다.
            int val = 1;
            for (int j = 0; j < 3; j++)
            {
                for (int i = 0; i < 3; i++)
                {
                    grid.SetValue(j, i, val);
                    val += 1;
                }
            }

            // 3. 입력된 grid객체의 값을 프린트한다.
            // 입력된 값을 얻을때는 Double형으로 캐스팅되어서 얻는다.
            double ret = 0;
            string strVal = "";
            for (int j = 0; j < 3; j++)
            {
                for (int i = 0; i < 3; i++)
                {
                    grid.GetValue(j, i, ref ret); strVal = strVal + ret.ToString( ) + " ";
                }
                strVal += "; ";
            }
            Console.WriteLine(strVal);

            // 4. 입력된 grid값에 대한 Flip을 수행한다. 
            XGrid horzFlip =new XGrid();
            grid.FlipHorz(out horzFlip);

            // 5. Flip된 grid객체의 값을 프린트한다.
            ret = 0;
            strVal = "";
            for (int j = 0; j < 3; j++)
            {
                for (int i = 0; i < 3; i++)
                {
                    horzFlip.GetValue(j, i, ref ret); strVal = strVal + ret.ToString() + " ";
                }
                strVal += "; ";
            }
            Console.WriteLine(strVal);


            // 6. 특정 Row를 얻는다.
            XGrid rowVec = new XGrid();
            horzFlip.GetRowVector(out rowVec, 1);
            strVal = "";
            for (int i = 0; i < 3; i++)
            {
                rowVec.GetValue(0, i, ref ret); strVal = strVal + ret.ToString() + " ";
            }
            Console.WriteLine(strVal);
        }
     }
}
